<template lang="pug">
  .stage-sizes-header(
    v-show="stageRealWidth && stageRealHeight"
    ref="stageSizes"
  )
    .current-size(@click="() => { if (currentSizeIndex !== null) toggle() }")
      template(v-if="currentSizeIndex === null")
        .change-form
          .inputs
            input(
              v-model="stageWidth"
              @click="showOkButton = true"
              :class="{ error: wrongWidth }"
            )
            div x
            input(
              v-model="stageHeight"
              @click="showOkButton = true"
              :class="{ error: wrongHeight }"
            )
          .save-button(
            v-if="showOkButton"
            @click.stop="saveSizes()"
            v-html="$icons.okBold"
            v-tooltip:bottom="'Set sizes'"
          )
          .menu-icon(
            v-else
            @click="toggle()"
            v-html="$icons.menuArrowDown"
          )
      template(v-else)
        div {{ sizes[currentSizeIndex].title }}
        div(v-if="sizes[currentSizeIndex].ratio") &nbsp; {{ sizes[currentSizeIndex].ratio }}
        div(v-else) &nbsp; {{ `${sizes[currentSizeIndex].width} x ${sizes[currentSizeIndex].height}` }}
        .menu-icon(v-html="$icons.menuArrowDown")
    .sizes-container(:class="{ shown: stageSizesShown, hidden: !stageSizesShown }")
      stage-sizes-panel(
        @select="changeSize"
        ref="stageSizes"
      )
</template>

<script>
import { mapState } from 'vuex'
import config from '../../config'
import storeService from '../../services/store'
import ResizeStageCommand from '../../history/commands/resizeStage'

export default {
  name: 'StageSizesHeader',
  data () {
    return {
      initialized: false,
      currentSizeIndex: null,
      sizes: config.stage.sizesPresets,
      showOkButton: false,
      wrongWidth: false,
      wrongHeight: false,
      stageWidth: null,
      stageHeight: null,
      maxWidth: config.stage.sideMaxWidth,
      maxHeight: config.stage.sideMaxWidth,
      minWidth: config.stage.minWidth,
      minHeight: config.stage.minHeight
    }
  },
  computed: {
    ...mapState({
      stageSizesShown: state => state.editor.stageSizesShown,
      stageRealWidth: state => state.editor.stage.realWidth,
      stageRealHeight: state => state.editor.stage.realHeight
    })
  },
  watch: {
    stageRealWidth () {
      this.handleStageSizeChange()
    },
    stageRealHeight () {
      this.handleStageSizeChange()
    },
    stageWidth () {
      this.checkSizes()
    },
    stageHeight () {
      this.checkSizes()
    }
  },
  mounted () {
    this.handleStageSizeChange()
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    toggle () {
      this.$store.dispatch('setStageSizesShown', !this.stageSizesShown)
    },
    changeSize (sizeIndex) {
      this.currentSizeIndex = sizeIndex
    },
    handleStageSizeChange () {
      this.stageWidth = this.stageRealWidth
      this.stageHeight = this.stageRealHeight
      if (!this.initialized) {
        this.findSizeIndex()
        this.initialized = true
      }
    },
    checkSizes () {
      const isStageWidthValid =
          /\d+/.test(this.stageWidth) &&
          this.stageWidth >= this.minWidth &&
          this.stageWidth <= this.maxWidth
      const isStageHeightValid =
          /\d+/.test(this.stageHeight) &&
          this.stageHeight >= this.minHeight &&
          this.stageHeight <= this.maxHeight

      this.wrongWidth = !isStageWidthValid
      this.wrongHeight = !isStageHeightValid

      return isStageWidthValid && isStageHeightValid
    },
    saveSizes () {
      if (this.checkSizes()) {
        this.showOkButton = false
        storeService.get('commandManager').execute(new ResizeStageCommand(this.stageWidth, this.stageHeight))
          .then(() => {
            this.findSizeIndex()
          })
      }
    },
    findSizeIndex () {
      // Check if sizes set are in the sizes list
      let sizePresetIndex
      this.sizes.forEach((sizePreset, index) => {
        if (sizePreset.width === this.stageRealWidth && sizePreset.height === this.stageRealHeight) {
          sizePresetIndex = index
        }
      })
      this.currentSizeIndex = sizePresetIndex === undefined ? null : sizePresetIndex
    },
    outsideClick (event) {
      if (!this.$refs.stageSizes.contains(event.target)) {
        this.$store.dispatch('setStageSizesShown', false)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../assets/css/mixins';

  .stage-sizes-header {
    color: #BDBDBD;
    font-size: 14px;
    position: relative;
    height: 100%;

    .current-size {
      height: 100%;
      position: relative;
      display: flex;
      flex-direction: row;
      align-items: flex-end;
      z-index: 10;
      background-color: #1a1a1a;
      cursor: pointer;

      .change-form {
        display: flex;
        flex-direction: row;
        align-items: center;

        .inputs {
          display: flex;
          flex-direction: row;
          align-items: center;

          input {
            width: 53px;
            height: 30px;
            text-align: center;
            border: none;
            font-size: 14px;
            font-weight: 300;
            background-color: rgba(255, 255, 255, 0.1);
            color: #fff;
            border-radius: 10px;
            margin: 0 5px;
            outline: none;
            @include font-regular;

            &.error {
              background-color: #482020;
            }
          }
        }

        .save-button {
          width: 16px;
          height: 18px;
          padding: 0 0 0 5px;
          stroke: #fff;
        }
      }

      .change-button {
        width: 21px;
        height: 21px;
        padding: 3px;
        fill: #aaa;
        display: none;

        &:hover {
          background-color: #333;
          fill: #fff;
          @include delay()
        }
      }
    }

    .sizes-container {
      width: 270px;
      border-radius: 8px;
      position: absolute;
      left: -72px;
      overflow: hidden;

      &.shown {
        opacity: 1;
        top: 32px;
        transition: top 0.2s, opacity 0.4s;
      }

      &.hidden {
        opacity: 0;
        top: -500px;
        transition: top 0.5s, opacity 0.2s;
      }
    }

    .menu-icon {
      width: 16px;
      height: 18px;
      padding: 0 0 0 5px;
      fill: #8c8c8c;
    }
  }
</style>
//
